#define F_CPU 3686400UL
#include <avr/io.h>
#include <util/delay.h>
#include <avr/wdt.h>

//8870 STD PC4

void znak_pc (char);
void pc_string (char *s);
char nacti_dtmf (void);
char s[32];
char dtmf3;
char dtmf2;
char dtmf1;
char dtmf0;
char dtmf;
char cislice;



//************ main ***********************

int main(void)
{



// PORT init
PORTB=0x00;
DDRB=0x00;

PORTC=0x00;
DDRC=0x20;

PORTD=0x00;
DDRD=0xF8;



// USART initialization
UCSRA=0x00;
UCSRB=0x08;
UCSRC=0x86;
UBRRH=0x00;
UBRRL=0x17;


//aktivace WDT
wdt_enable(WDTO_2S);



	PORTC &= ~(1<<5); //led kratce blikne
	_delay_ms(10);
	PORTC |= (1<<5);


	pc_string("reset\r\n");



    while(1) 
    {

	cislice=nacti_dtmf();	//funkce vrati znak po pusteni klavesy
	wdt_reset();	
	znak_pc(cislice);

	if (cislice=='1')
	{
	pc_string("\r\n");
	pc_string("prvni OK\r\n");
	PORTD |= (1<<4);//prvni cislice OK rozsviti prvni led
	
	cislice=nacti_dtmf();
	wdt_reset();
	znak_pc(cislice);
		
		if (cislice=='2')
		{
		pc_string("\r\n");
		pc_string("druha OK\r\n");
		PORTD |= (1<<5);
		cislice=nacti_dtmf();
		wdt_reset();		
		znak_pc(cislice);		
		
			if (cislice=='3')
			{
			pc_string("\r\n");
			pc_string("treti OK\r\n");
			PORTD |= (1<<6);
	
			cislice=nacti_dtmf();
			wdt_reset();
			znak_pc(cislice);		
		
				if (cislice=='4')
				{
				pc_string("\r\n");
				pc_string("ctvrta OK\r\n");
				PORTD |= (1<<7);
				pc_string("VSECHNY SOUHLASI\r\n");
				
				//sepni rele
				PORTD |= (1<<3);
				wdt_reset();	
				_delay_ms(1500);
				wdt_reset();
				PORTD &= ~(1<<3); 
				wdt_reset();
				_delay_ms(1000);
				wdt_reset();
				PORTD &= ~(1<<4);//zhasne 4 led kodu
				PORTD &= ~(1<<5);
				PORTD &= ~(1<<6);
				PORTD &= ~(1<<7);
	

/*
				PORTD |= (1<<3);
				wdt_reset();	
				_delay_ms(1500);
				wdt_reset();
				PORTD &= ~(1<<3); 
				wdt_reset();
				_delay_ms(1000);
				wdt_reset();

				PORTD |= (1<<3);
				wdt_reset();	
				_delay_ms(1500);
				wdt_reset();
				PORTD &= ~(1<<3); 
				wdt_reset();
				_delay_ms(1000);
				wdt_reset();
*/
				}
			}
		}
	}

	pc_string("\r\n");		
	pc_string("konec retezu IF");	

    }

       
}







//***********************************
//znak odeslat na PC
//***********************************

void znak_pc(char c)
{
	while ((UCSRA & (1<<UDRE))==0);
	{
	UDR=c;
	}
}

//***********************************
//odeslat retezec na pc
//***********************************

void pc_string(char *s )

{
	while ( *s ) 
	{

		znak_pc( *s++ );
	}
}



//***********************************
//dekodovani znaku
//***********************************


char nacti_dtmf (void)
    {

	while(!((PINC & (1<<4))?1:0)); //dokud je STD nula, ceka



//bit Q4 PC0
	if((PINC & (1<<0))?1:0) //
	{
	dtmf3=0b00001000;
	}
	else
	{
	dtmf3=0b00000000;
	}

//bit Q3 PC1
	if((PINC & (1<<1))?1:0) //
	{
	dtmf2=0b00000100;
	}
	else
	{
	dtmf2=0b00000000;
	}


//bit Q2 PC2
	if((PINC & (1<<2))?1:0) //
	{
	dtmf1=0b00000010;
	}
	else
	{
	dtmf1=0b00000000;
	}

//bit Q1 PC3
	if((PINC & (1<<3))?1:0) //
	{
	dtmf0=0b00000001;
	}
	else
	{
	dtmf0=0b00000000;
	}

//secteme jednotlive rady
	dtmf=dtmf0+dtmf1+dtmf2+dtmf3;

//8870 dekoduje nulu jako 1010, tedy upravime
	if(dtmf==0b00001010) //
	{
	dtmf=0b00000000;
	}
	else
	{
	
	}

//8870 dekoduje * jako 1011, tedy upravime
	if(dtmf==0b00001011) //
	{
	dtmf=250;
	}
	else
	{
	
	}

//8870 dekoduje # jako 1100, tedy upravime
	if(dtmf==0b00001100) //
	{
	dtmf=243;
	}
	else
	{
	
	}


//a pricteme ascii 0 pro zobrazeni na pc
	dtmf=dtmf+'0';

	while(((PINC & (1<<4))?1:0)); //dokud je STD jedna, ceka

return dtmf;

    }



















